Index: trunk/include/FlairCore/AhrsData.h
===================================================================
--- trunk/include/FlairCore/AhrsData.h	(revision 74)
+++ trunk/include/FlairCore/AhrsData.h	(revision 76)
@@ -161,12 +161,12 @@
 private:
   /*!
-  * \brief Copy datas
+  * \brief Raw read datas
   *
   * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
+  * See io_data::RawRead.
   *
   * \param dst destination buffer
   */
-  void CopyDatas(char *dst) const;
+  void RawRead(char *dst) const;
 
   void Queue(char **dst, const void *src, size_t size) const;
Index: trunk/include/FlairCore/FrameworkManager.h
===================================================================
--- trunk/include/FlairCore/FrameworkManager.h	(revision 74)
+++ trunk/include/FlairCore/FrameworkManager.h	(revision 76)
@@ -77,5 +77,5 @@
   * \param rcv_buf_size receive buffer size
   */
-  void SetupConnection(std::string address, uint16_t port,Time watchdogTimeout=(Time)1000000000,
+  void SetupConnection(std::string address, uint16_t port,Time watchdogTimeout=(Time)1500000000,
                        size_t rcv_buf_size = 10000);
 
Index: trunk/include/FlairCore/GeoCoordinate.h
===================================================================
--- trunk/include/FlairCore/GeoCoordinate.h	(revision 74)
+++ trunk/include/FlairCore/GeoCoordinate.h	(revision 76)
@@ -96,12 +96,12 @@
 private:
   /*!
-  * \brief Copy datas
+  * \brief Raw read datas
   *
   * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
+  * See io_data::RawRead.
   *
   * \param dst destination buffer
   */
-  void CopyDatas(char *ptr) const;
+  void RawRead(char *ptr) const;
 
   double latitude;
Index: trunk/include/FlairCore/GpsData.h
===================================================================
--- trunk/include/FlairCore/GpsData.h	(revision 74)
+++ trunk/include/FlairCore/GpsData.h	(revision 76)
@@ -244,16 +244,16 @@
 
   Type const &GetDataType() const { return dataType; }
+  
+  /*!
+  * \brief Raw read datas
+  *
+  * Reimplemented from io_data. \n
+  * See io_data::RawRead.
+  *
+  * \param dst destination buffer
+  */
+  void RawRead(char *dst) const;
 
 private:
-  /*!
-  * \brief Copy datas
-  *
-  * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
-  *
-  * \param dst destination buffer
-  */
-  void CopyDatas(char *dst) const;
-
   void Queue(char **dst, const void *src, size_t size) const;
   Type dataType;
Index: trunk/include/FlairCore/ImuData.h
===================================================================
--- trunk/include/FlairCore/ImuData.h	(revision 74)
+++ trunk/include/FlairCore/ImuData.h	(revision 76)
@@ -186,12 +186,12 @@
 private:
   /*!
-  * \brief Copy datas
+  * \brief Raw read datas
   *
   * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
+  * See io_data::RawRead.
   *
   * \param dst destination buffer
   */
-  void CopyDatas(char *dst) const;
+  void RawRead(char *dst) const;
 
   /*!
Index: trunk/include/FlairCore/Matrix.h
===================================================================
--- trunk/include/FlairCore/Matrix.h	(revision 74)
+++ trunk/include/FlairCore/Matrix.h	(revision 76)
@@ -194,16 +194,25 @@
 
   Type const &GetDataType() const { return dataType; };
-void CopyDatas(char *dst) const;
+  
+  /*!
+  * \brief Raw read datas
+  *
+  * Reimplemented from io_data. \n
+  * See io_data::RawRead.
+  *
+  * \param dst destination buffer
+  */
+  void RawRead(char *dst) const;
+
+  /*!
+  * \brief Raw write datas
+  *
+  * Copy the source to the internal datas. Source must be of the corresponding size.
+  *
+  * \param src source buffer
+  */
+  void RawWrite(char *src);
+  
 private:
-  /*!
-  * \brief Copy datas
-  *
-  * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
-  *
-  * \param dst destination buffer
-  */
-  //void CopyDatas(char *dst) const;
-
   class Matrix_impl *pimpl_;
   Type dataType;
Index: trunk/include/FlairCore/Vector3Ddata.h
===================================================================
--- trunk/include/FlairCore/Vector3Ddata.h	(revision 74)
+++ trunk/include/FlairCore/Vector3Ddata.h	(revision 76)
@@ -78,5 +78,5 @@
   *
   * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
+  * See io_data::RawRead.
   *
   * \param dst destination buffer
Index: trunk/include/FlairCore/cvimage.h
===================================================================
--- trunk/include/FlairCore/cvimage.h	(revision 74)
+++ trunk/include/FlairCore/cvimage.h	(revision 76)
@@ -108,12 +108,12 @@
 private:
   /*!
-  * \brief Copy datas
+  * \brief Raw read datas
   *
   * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
+  * See io_data::RawRead.
   *
   * \param dst destination buffer
   */
-  void CopyDatas(char *dst) const;
+  void RawRead(char *dst) const;
 
   bool allocate_data;
Index: trunk/include/FlairCore/cvmatrix.h
===================================================================
--- trunk/include/FlairCore/cvmatrix.h	(revision 74)
+++ trunk/include/FlairCore/cvmatrix.h	(revision 76)
@@ -209,5 +209,5 @@
   *
   * Reimplemented from io_data. \n
-  * See io_data::CopyDatas.
+  * See io_data::RawRead.
   *
   * \param dst destination buffer
Index: trunk/include/FlairCore/io_data.h
===================================================================
--- trunk/include/FlairCore/io_data.h	(revision 74)
+++ trunk/include/FlairCore/io_data.h	(revision 76)
@@ -176,4 +176,26 @@
 
   virtual DataType const &GetDataType() const = 0;
+  
+  /*!
+  * \brief Raw write datas
+  *
+  * Copy the source to the internal datas. Source must be of the corresponding size.
+  *
+  * \param src source buffer
+  */
+  virtual void RawWrite(char *src)  {};//todo put pure virtual
+  
+  /*!
+  * \brief Raw read datas
+  *
+  * This method is automatically called by IODevice::ProcessUpdate to log
+  * io_data datas. \n
+  * This method must be reimplemented, in order to copy the datas to the logs.
+  * Copy the internal datas to destination. Destination must be of the corresponding size.
+  *
+  * \param dst destination buffer
+  */
+  virtual void RawRead(char *dst) const = 0;
+
 
 protected:
@@ -208,16 +230,4 @@
 
 private:
-  /*!
-  * \brief Copy datas
-  *
-  * This method is automatically called by IODevice::ProcessUpdate to log
-  *io_data datas. \n
-  * This method must be reimplemented, in order to copy the datas to the logs.
-  * Copied datas must be of size io_data::Size.
-  *
-  * \param dst destination buffer
-  */
-  virtual void CopyDatas(char *dst) const = 0;
-
   io_data_impl *pimpl_;
 };
Index: trunk/include/FlairFilter/Pid.h
===================================================================
--- trunk/include/FlairFilter/Pid.h	(revision 74)
+++ trunk/include/FlairFilter/Pid.h	(revision 76)
@@ -58,4 +58,12 @@
   */
   void Reset(void);
+  
+   /*!
+  * \brief Get intergral part
+  *
+  * \return current integral part
+  */
+  float GetIntegral(void) const;
+
 
   /*!
Index: trunk/include/FlairSensorActuator/TargetController.h
===================================================================
--- trunk/include/FlairSensorActuator/TargetController.h	(revision 74)
+++ trunk/include/FlairSensorActuator/TargetController.h	(revision 76)
@@ -82,5 +82,5 @@
   // axis stuff
   unsigned int axisNumber;
-  core::Matrix *axis = NULL;
+  core::Matrix *axis = nullptr;
   virtual void AcquireAxisData(core::Matrix &axis) = 0; // responsible for
                                                           // getting the axis
@@ -90,5 +90,5 @@
   // button stuff
   unsigned int buttonNumber;
-  core::Matrix *button = NULL;
+  core::Matrix *button = nullptr;
   virtual void AcquireButtonData(core::Matrix &button) = 0; // responsible for
                                                               // getting the
Index: trunk/include/FlairSensorActuator/TargetEthController.h
===================================================================
--- trunk/include/FlairSensorActuator/TargetEthController.h	(revision 74)
+++ trunk/include/FlairSensorActuator/TargetEthController.h	(revision 76)
@@ -77,8 +77,8 @@
   core::TcpSocket *listeningSocket;
   int listeningPort;
-  core::TcpSocket *controlSocket = NULL;
+  core::TcpSocket *controlSocket = nullptr;
   core::UdpSocket *dataSocket;
-  std::string *axisName = NULL;
-  std::string *buttonName = NULL;
+  std::string *axisName = nullptr;
+  std::string *buttonName = nullptr;
   size_t dataFrameSize;
   char *dataFrameBuffer;
Index: trunk/include/FlairVisionFilter/OpticalFlowData.h
===================================================================
--- trunk/include/FlairVisionFilter/OpticalFlowData.h	(revision 74)
+++ trunk/include/FlairVisionFilter/OpticalFlowData.h	(revision 76)
@@ -129,4 +129,14 @@
 
         OpticalFlowData::Type const &GetDataType() const {return dataType;}
+        
+        /*!
+        * \brief Raw read datas
+        *
+        * Reimplemented from io_data. \n
+        * See io_data::RawRead.
+        *
+        * \param dst destination buffer
+        */
+        void RawRead(char *dst) const;
 
     private:
@@ -137,5 +147,4 @@
         char *found_features;
         uint32_t *features_error;
-        void CopyDatas(char* dst) const;
         Type dataType;
     };
